#!/bin/bash
dist="$1"
count="0"
max="100"
function blue { usleep 100000 ; echo -n "[44m " ; }

if [ "$UID" != "0" ]; then
echo "You have to be root to install this."
exit -1
fi

echo "Installing rpm-get"

ok="[ [1;32mOK[0m ]"
fail="[ [5m[1;31mFAILD[0m ]"
present="[ [1;33mPRESENT[0m ]"
create="[ [1;35mCREATING[0m ]"

if [ "$dist" == "" ]; then
echo "Usage: $0 [--mandrake || --redhat]"
exit 0
fi

dialog --msgbox "You have chosen to install rpm-get 1.5 for `echo $dist | awk -F'--' '{print $2}'` ?" 10 50 || exit -1

if [ ! -f /var/lib/rpm-get ]; then
mkdir -p /var/lib/rpm-get
fi

echo -n "Where would you like to cache the rpm files ? [/var/cache/rpm-get]: "
read CACHE
if [ "x$CACHE" == "x" ]; then
CACHE="/var/cache/rpm-get"
fi

if [ ! -f $CACHE ]; then
mkdir -p $CACHE
chown root.root $CACHE
chmod 0700 $CACHE
else
echo "Warning:" 
echo "there where already an $CACHE directory, make sure only"
echo "root can write to it: "
echo "chown root.root $CACHE"
echo "chmod 0700 $CACHE"
fi

echo "Which ftp site/path would you like to use ?"
echo "If nothing here suits you, or the mirror you chose is out of date"
echo "you can change the /etc/rpm-get.conf by hand later"
echo -n '[Press enter to see a list or type "default" to use a Swedish site]: '
read ftp

if [ "$ftp" == "default" ]; then
   if [ "$dist" == "--mandrake" ]; then
      cat /etc/rpm-get.conf | sed 's/DISTRIBUTION/MANDRAKE/g' > /tmp/rpm-get.tmp
      cat /tmp/rpm-get.tmp | sed 's|ftp-path-to-packages|ftp://ftp.sunet.se/pub/Linux/distributions/mandrake/current/i586/Mandrake|g' > /etc/rpm-get.conf
      cat /etc/rpm-get.conf | sed 's|ftp-path-to-updates|ftp://ftp.sunet.se/pub/Linux/distributions/mandrake/updates/8.0/RPMS|g' > /tmp/rpm-get.tmp
      cat /tmp/rpm-get.tmp | sed 's|ftp-path-to-sources|ftp://ftp.sunet.se/pub/Linux/distributions/mandrake/current/SRPMS|g' > /etc/rpm-get.conf
   fi
   if [ "$dist" == "--redhat" ]; then
      cat /etc/rpm-get.conf | sed 's/DISTRIBUTION/REDHAT/g' > /tmp/rpm-get.tmp
      cat /tmp/rpm-get.tmp | sed 's|ftp-path-to-packages|ftp://ftp.sunet.se/pub/Linux/distributions/redhat/redhat/redhat-7.1-en/os/i386/RedHat|g' > /etc/rpm-get.conf
      cat /etc/rpm-get.conf | sed 's|ftp-path-to-updates|N/A|g' > /tmp/rpm-get.tmp
      cat /tmp/rpm-get.tmp | sed 's|ftp-path-to-sources|ftp://ftp.sunet.se/pub/Linux/distributions/redhat/redhat/redhat-7.1-en/os/i386/SRPMS|g' > /etc/rpm-get.conf
   fi
fi

if [ "x$ftp" == "x" ]; then
   if [ "$dist" == "--mandrake" ]; then
more << EOF
NO ftp://sunsite.uio.no/
US ftp://rufus.w3.org/
US2 (Boston) ftp://rpmfind.net/
UK ftp://ftp.mirror.ac.uk/
FI ftp://ftp.clinet.fi/
EOF
echo
echo -n "[Enter ftp site, ie. US2 for the ftp site in Boston]: "
read country

   if [ "$country" == "NO" ]; then
      ftppath="ftp://sunsite.uio.no/pub/linux/Mandrake/current/i586/Mandrake"
      updatepath="ftp://sunsite.uio.no/pub/linux/Mandrake/updates/8.0/RPMS"
      sourcepath="ftp://sunsite.uio.no/pub/linux/Mandrake/current/SRPMS"
   fi
   if [ "$country" == "US" ]; then
      ftppath="ftp://rufus.w3.org/linux/Mandrake/current/i586/Mandrake"
      updatepath="ftp://rufus.w3.org/linux/Mandrake/updates/8.0/RPMS"
      sourcepath="ftp://rufus.w3.org/linux/Mandrake/current/SRPMS"
   fi
   if [ "$country" == "US2" ]; then
      ftppath="ftp://rpmfind.net/linux/Mandrake/current/Mandrake"
      updatepath="ftp://rpmfind.net/linux/Mandrake/updates/8.0/RPMS"
      sourcepath="ftp://rpmfind.net/linux/Mandrake/current/SRPMS"
   fi
   if [ "$country" == "UK" ]; then
      ftppath="ftp://ftp.mirror.ac.uk/sites/sunsite.uio.no/pub/unix/Linux/Mandrake/current/i586/Mandrake"
      updatepath="ftp://ftp.mirror.ac.uk/sites/sunsite.uio.no/pub/unix/Linux/Mandrake/updates/8.0/RPMS"
      sourcepath="ftp://ftp.mirror.ac.uk/sites/sunsite.uio.no/pub/unix/Linux/Mandrake/current/SRPMS"
   fi
   if [ "$country" == "FI" ]; then
      ftppath="ftp://ftp.clinet.fi/mirrors/ftp.linux-mandrake.com/current/i586/Mandrake"
      updatepath="ftp://ftp.clinet.fi/mirrors/ftp.linux-mandrake.com/updates/8.0/RPMS"
      sourcepath="ftp://ftp.clinet.fi/mirrors/ftp.linux-mandrake.com/current/SRPMS"
   fi
 fi

 if [ "$dist" == "--redhat" ]; then
more << EOF
NO ftp://sunsite.uio.no/
US ftp://rufus.w3.org/
US2 (Boston) ftp://rpmfind.net/
FR (No update dir) ftp://ftp.univ-savoie.fr/ 
EOF
echo
echo -n "[Enter ftp site, ie. US2 for the ftp site in Boston]: "
read country

  if [ "$country" == "NO" ]; then
    ftppath="ftp://sunsite.uio.no/linux/RedHat/redhat/current/en/os/i386/RedHat"
    updatepath="ftp://sunsite.uio.no/linux/RedHat/updates/current/en/os/i386"
    sourcepath="ftp://sunsite.uio.no/linux/RedHat/redhat/current/en/os/i386/SRPMS"
  fi
  if [ "$country" == "US" ]; then
     ftppath="ftp://rufus.w3.org/linux/redhat/current/en/os/i386/RedHat"
     updatepath="ftp://rufus.w3.org/linux/redhat/updates/current/en/os/i386"
     sourcepath="ftp://rufus.w3.org/linux/redhat/current/en/os/i386/SRPMS"
  fi
  if [ "$country" == "US2" ]; then
     ftppath="ftp://rpmfind.net/linux/redhat/current/en/os/i386/RedHat"
     updatepath="ftp://rpmfind.net/linux/redhat/updates/current/en/os/i386"
     sourcepath="ftp://rpmfind.net/linux/redhat/current/en/os/i386/SRPMS"
  fi
  if [ "$country" == "FR" ]; then
     ftppath="ftp://ftp.univ-savoie.fr/pub/Linux/RedHat/redhat-7.1-en/os/i386/RedHat"
     updatepath="N/A"
     sourcepath="ftp://ftp.univ-savoie.fr/pub/Linux/RedHat/redhat-7.1-en/os/i386/SRPMS"
  fi
 fi
fi
reset
clear

echo ; echo ; echo ; echo ; echo ; echo ; echo ; echo ; echo ; echo ; echo ; echo ; echo ; echo ; echo ; echo
echo "                           [0;36mMoving to second stage[0m"
echo ; sleep 1
echo -n "                  * "
blue ; blue ; blue ; blue ; blue ; blue ; blue ; blue ; blue ; blue ; blue
blue ; blue ; blue ; blue ; blue ; blue ; blue ; blue ; blue ; blue ; blue
blue ; blue ; blue ; blue ; blue ; blue ; blue ; blue ; blue ; blue ; blue
blue ; blue ; blue ; echo "[0m *"
sleep 2

reset
clear

if [ "$dist" == "--mandrake" ]; then
echo -n "Configuring for Mandrake                                      "
sleep 1
cat rpm-get.conf | sed 's/DISTRIBUTION/MANDRAKE/g' > rpm-get.tmp
cat rpm-get.tmp | sed 's|ftp-path-to-packages|'$ftppath'|g' > rpm-get.conf
cat rpm-get.conf | sed 's|ftp-path-to-updates|'$updatepath'|g' > rpm-get.tmp
cat rpm-get.tmp | sed 's|CACHE|'$CACHE'|g' > rpm-get.conf
cat rpm-get.conf | sed 's|ftp-path-to-sources|'$sourcepath'|g' > rpm-get.tmp
mv -f rpm-get.tmp rpm-get.conf
echo "$ok"
fi

if [ "$dist" == "--redhat" ]; then
echo -n "Configuring for RedHat                                        "
cat rpm-get.conf | sed 's/DISTRIBUTION/REDHAT/g' > rpm-get.tmp
cat rpm-get.tmp | sed 's|ftp-path-to-packages|'$ftppath'|g' > rpm-get.conf
cat rpm-get.conf | sed 's|ftp-path-to-updates|'$updatepath'|g' > rpm-get.tmp
cat rpm-get.tmp | sed 's|CACHE|'$CACHE'|g' > rpm-get.conf
rm -f rpm-get.tmp
sleep 1
echo "$ok"
fi

function check { 
if [ "`which $1 2>/dev/null`" == "" ];then
sleep 1 
echo $fail
echo "You need to install $1 to run rpm-get"
exit 0 
else sleep 1
echo $ok 
fi
}

echo -n "Checking for lynx                                             "
check lynx
echo -n "Checking for awk                                              "
check awk
echo -n "Checking for sed                                              "
check sed
echo -n "Checking for rpm                                              "
check rpm
echo -n "Checking for wget                                             "
check wget
echo -n "Checking for tr                                               "
check tr
echo -n "Checking for config files                                     "
sleep 1
if [ -f /etc/rpm-get.conf ]; then
echo "$present"
echo -n "Checking for config file Version                              "
sleep 1

if grep "Version-0.5" /etc/rpm-get.conf 1>/dev/null 2>&1 ; then
echo "$ok" 
else 
echo "$fail"
echo -n "Creating new config file                                      "
cp -rf rpm-get.conf /etc/ 
sleep 1 
echo "$ok"
fi

else
echo "$create"
cp -rf rpm-get.conf /etc/
fi
sleep 1
echo
echo "      Creating Directorys and Database files, this might take time."
echo "                     Go buy a pizza or something.                  "
echo

cp -rf {rpm-get-configure,rpm-get,genrpmlist,dep-check.sh,rpm-dep.sh,rpm-fle2pkg.sh} /sbin/
chmod 755 /sbin/genrpmlist
/sbin/genrpmlist

echo
echo "        Installing manual page and doing post-install configurations." 

cp -rf rpm-get.1.bz2 /usr/man/man1/rpm-get.1.bz2

chmod 644 /var/lib/rpm-get/RPMS-list
chmod 644 /var/lib/rpm-get/SRPMS-list

if [ "$dist" == "--mandrake" ]; then
chmod 644 /var/lib/rpm-get/RPMS2-list
fi

chmod 755 /sbin/{rpm-get-configure,rpm-get,genrpmlist,dep-check.sh,rpm-dep.sh,rpm-fle2pkg.sh}
chmod 644 /etc/rpm-get.conf
sleep 1
echo ; echo "                               [ [1;34mINSTALLED[0m ]"
echo
exit 0